/* Copyright (C) 2006-2012 VA007219 */
#include <windows.h>
#include <Richedit.h>
#include <shellapi.h>
#include <commctrl.h>
#include <process.h>
#include <tchar.h>
#include <stdio.h>
#include <string.h>
#include <strsafe.h>
#ifdef DEBUG
#include <crtdbg.h>
#endif
#include "resource.h"
#ifdef BCC32
typedef unsigned long _RTLENTRY _EXPFUNC uintptr_t;
#endif

#ifdef UNICODE
int iskanji(int x)
{
   if ( x >=0xd800 && x <= 0xdbff ) {
        return 1;
   } else {
       return 0;
   }
}
#endif

struct threaddatatype {
    unsigned int threadid;
    HANDLE threadhandle;
    int exitcode;
    HWND hWnd;
    int id1;
    int id2;
    int id3;
    int id4;
    int *pstopflag;
    int threadendflag;
};

struct threaddatatype threaddata;

int globalalloc(void);
void globalfree(void);

/* 4 ʏ|3 ᕉ|2 |1 ACh */
extern int prio;
/*
1 ACh: CPU       FILEԊu
2 ᑬ:     CPUʏȉ FILEᑬ
3 ᕉ:   CPUʏȉ FILEʏ
4 ʏ:     CPUʏ     FILEʏ
*/
DWORD tocount[] = {
/*0    1     2     3   4*/
40000,40000,10000,10000,0,
};

int npriority[] = {
THREAD_PRIORITY_LOWEST,
THREAD_PRIORITY_LOWEST,/* 1 */
THREAD_PRIORITY_BELOW_NORMAL,/* 2 */
THREAD_PRIORITY_BELOW_NORMAL,/* 3 */
THREAD_PRIORITY_NORMAL,/* 4 */
};

/* main thread , sub thread */
_TCHAR *getinikey(_TCHAR *av0,_TCHAR *section,_TCHAR *key);/*}`Xbhł̓gps*/
_TCHAR *truepath(_TCHAR *file);

/* main thread */
_TCHAR *seldir(HWND hWnd,_TCHAR *indir,_TCHAR *title);
int setpath1(HWND hWnd,_TCHAR *buf,_TCHAR **msg);
int setpath2(HWND hWnd,_TCHAR *buf,_TCHAR **msg);
int setflags(_TCHAR *flag1,_TCHAR *flage);
int startup(HWND hWnd,int id);
int fixup(HWND hWnd,_TCHAR **msg);
int percent(_TCHAR *p,int i);

/* sub thread */
int dfdsub(HWND hWnd,int id1,int id2,int id3,int id4,int *pstopflag);

_TCHAR *pgname0 = _T("dfd64");

_TCHAR scrnbuff[4096 + LONGMAX_PATH];
_TCHAR msgbuff[4096 + LONGMAX_PATH];

int stdprintf(_TCHAR *fmt,...)
{
    va_list argp;
    int ret;
    int sts;

    if ( fmt != NULL && *fmt != 0 ) {
        va_start(argp, fmt);
        ret = _vsntprintf(msgbuff,(sizeof msgbuff / sizeof msgbuff[0]) - 1,fmt,argp);
        va_end(argp);
    }
    sts = MessageBox(NULL,msgbuff,pgname0,MB_OKCANCEL);
    if ( sts == IDCANCEL ) {
        PostQuitMessage(1);
    }
    return ret;
}

extern int lasterror;

void errprint(_TCHAR *fmt, ...)
{
    LPVOID lpMsgBuf;
    va_list argp;

    if ( fmt != NULL && *fmt != 0 ) {
        va_start(argp, fmt);
         _vsntprintf(scrnbuff,(sizeof scrnbuff / sizeof scrnbuff[0]) - 1,fmt,argp);
        va_end(argp);
    }
    FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        lasterror,
        MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0,
        NULL
    );
    /*_tcscat(scrnbuff,lpMsgBuf);*/
    StringCbCat(scrnbuff,sizeof scrnbuff / sizeof scrnbuff[0],lpMsgBuf);
    LocalFree(lpMsgBuf);
    stdprintf(_T("%s"),scrnbuff);
}

static _TCHAR voidstring[] = _T("");

LPTSTR loadstring(HINSTANCE hInstance, UINT uID)
{
    _TCHAR buff[1024];
    int size;
    int sts;
    LPTSTR p;

    sts = LoadString(hInstance, uID, buff, (sizeof buff / sizeof buff[0]) - 1);
    if ( sts == 0 ) {
        sts = 1;
        buff[0] = 0;
    }
    p = _tcsdup(buff);
    if ( p == NULL ) {
        p = voidstring;
    }
    return p;
}

#ifdef DEBUG
void dfdlog(char *fmt, ...)
{
    LPVOID lpMsgBuf;
    va_list argp;
    SYSTEMTIME st;
    HANDLE h;
    DWORD fileposlow;
static char lbuff[1024 + LONGMAX_PATH];
    DWORD NumberOfBytesToWrite;
    int sts;

    GetLocalTime(&st);
    _snprintf(lbuff,sizeof lbuff / sizeof lbuff[0] - 1,"\r\n%04d-%02d-%02d %02d:%02d:%02d.%03d PID=%u TID=%u ",
      st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute,st.wSecond,st.wMilliseconds,GetCurrentProcessId(),GetCurrentThreadId());
    lbuff[sizeof lbuff / sizeof lbuff[0] - 1] = 0;
    h = CreateFile(_T("dfd.log"),GENERIC_WRITE,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN,NULL);
    if ( h == INVALID_HANDLE_VALUE ) return;
    fileposlow = SetFilePointer(h,0,NULL,FILE_END);
    if ( fileposlow == INVALID_SET_FILE_POINTER ) {
        CloseHandle(h);
        return;
    }
    sts = WriteFile(h,lbuff,strlen(lbuff),&NumberOfBytesToWrite,NULL);
    if ( fmt != NULL && *fmt != 0 ) {
        va_start(argp, fmt);
         _vsnprintf(lbuff,sizeof lbuff / sizeof lbuff[0] - 1,fmt,argp);
        va_end(argp);
    }
    sts = WriteFile(h,lbuff,strlen(lbuff),&NumberOfBytesToWrite,NULL);
    CloseHandle(h);
    return;
}
#define LOG
#else
void dfdlog(){}
#define LOG if(0)
#endif

int stopflag;

void sendthreadendmsg(HWND hWnd)
{
LOG dfdlog("LINE=%d sendthreadendmsg(HWND hWnd=%d)",__LINE__,hWnd);
    PostMessage(hWnd,WM_APP + 0x0100,0,0);
}

/* sub thread */
unsigned __stdcall subthread(void *lpvoid)
{
    int sts;

LOG dfdlog("LINE=%d subthread(void *lpvoid=%d)",__LINE__,lpvoid);
    sts = dfdsub(((struct threaddatatype *)lpvoid)->hWnd,
                   ((struct threaddatatype *)lpvoid)->id1,
                   ((struct threaddatatype *)lpvoid)->id2,
                   ((struct threaddatatype *)lpvoid)->id3,
                   ((struct threaddatatype *)lpvoid)->id4,
                   ((struct threaddatatype *)lpvoid)->pstopflag);
    ((struct threaddatatype *)lpvoid)->threadendflag = 1;
    sendthreadendmsg(((struct threaddatatype *)lpvoid)->hWnd);
LOG dfdlog("LINE=%d _endthreadex(sts=%d)",__LINE__,sts);
     _endthreadex(sts);
    return sts;
}

int startthread(HWND hWnd,_TCHAR **errmsg)
{
    unsigned int threadid;
    HANDLE threadhandle;
    BOOL sts;

LOG dfdlog("LINE=%d startthread(HWND hWnd=%d,_TCHAR **errmsg)",__LINE__,hWnd);
    threaddata.threadid = 0;
    threaddata.threadhandle = 0;
    threaddata.exitcode = -1;
    threaddata.hWnd = hWnd;
    threaddata.id1 = IDSTS;
    threaddata.id2 = IDOLSTS;
    threaddata.id3 = IDPERCENT;
    threaddata.id4 = IDNUMBERS;
    threaddata.pstopflag = &stopflag;
    threaddata.threadendflag = 0;
LOG dfdlog("LINE=%d _beginthreadex(NULL,0,subthread,&threaddata=%p,0,&threadid)",__LINE__,&threaddata);
    threadhandle = (HANDLE)_beginthreadex(NULL,0,subthread,&threaddata,0,&threadid);
    if ( threadhandle ) {
        threaddata.threadhandle = threadhandle;
        threaddata.threadid = threadid;
        threaddata.exitcode = STILL_ACTIVE;
        sts = SetThreadPriority(threadhandle,npriority[prio]);
LOG dfdlog("LINE=%d SetThreadPriority(threadhandle=%d,[prio=%d])=%d",__LINE__,threadhandle,prio,sts);
        return 0;
    } else {
        *errmsg = _tcserror(errno);
        return 1;
    }
}

LPTSTR ClassName;
LPTSTR MenuName;
LPTSTR WindowName;
LPTSTR DialogName;
LPTSTR Version;
LPTSTR About;
LPTSTR SeldirName;
LPTSTR SeldirName2;
LPTSTR EmptyFolderName;
LPTSTR CantCreateFolderName;
LPTSTR Alreadythread;
LPTSTR Abortthread;
LPTSTR Abortedthread;
LPTSTR Initmsg;
LPTSTR EndJob;
LPTSTR ContAbort;
LPTSTR Percent;
LPTSTR Lock;
LPTSTR Priority;
LPTSTR Priority0;

int closethread(HWND hWnd,_TCHAR **errmsg)
{
static _TCHAR err[256];
    int sts;

LOG dfdlog("LINE=%d closethread(HWND hWnd=%d,_TCHAR **errmsg)",__LINE__,hWnd);
    if ( threaddata.exitcode == STILL_ACTIVE ) {
LOG dfdlog("LINE=%d hreaddata.exitcode == STILL_ACTIVE",__LINE__);
    }
    sts = CloseHandle((HANDLE)threaddata.threadhandle);
    if ( sts ) {
        threaddata.threadid = 0;
        threaddata.threadhandle = 0;
        threaddata.threadendflag = 0;
        if ( stopflag == 1 ) {
            SetDlgItemText(hWnd, IDOLSTS, Abortedthread);
        }
LOG dfdlog("LINE=%d sts=%d closethread()=0 stopflag=%d",__LINE__,stopflag);
        return 0;
    } else {
        _sntprintf(err,(sizeof err / sizeof err[0]) - 1,_T("Internal Error:closethread:CloseHandle(%d)=%d,threadid=%d"),threaddata.threadhandle,GetLastError(),threaddata.threadid);
        *errmsg = err;
        threaddata.threadid = 0;
        threaddata.threadhandle = 0;
        threaddata.threadendflag = 0;
LOG dfdlog("LINE=%d closethread()=1 stopflag=%d",__LINE__,stopflag);
        return 1;
    }
}

HINSTANCE viewdoc(HWND hWnd,LPCTSTR lpFile,LPCTSTR lpDirectory)
{
    HINSTANCE h;

    h = ShellExecute(
      hWnd,              // eEBhẼnh
      NULL,         // 
      lpFile,         // Ώۂ̃t@C
      NULL,   // ̃p[^
      lpDirectory,    // ̃fBNg
      SW_SHOWNORMAL            // \
    );
    return h;
}

_TCHAR *pdirname;

HCURSOR hcur;
HCURSOR hcur0;

int progexitcode;

void setflag(int size,_TCHAR *flag,int c)
{
    _TCHAR x[2];

    x[0] = c;
    x[1] = 0;
    if ( size > _tcslen(flag) + 1 ) {
        /*_tcscat(flag,x);*/
        StringCbCat(flag,size * sizeof(_TCHAR),x);
    }
}

int dragmode;
/*
hbv悪EDIT1EDIT2̊O
0 ȂłȂ ̂ŎEDIT1
1 EDIT1Ƀhbv ̂ŎEDIT2
0 EDIT2Ƀhbv ̂ŎEDIT1

EDIT1ɃhbvƂ1ɂ
EDIT2ɃhbvƂ0ɂ
*/

int settime(__int64 *x)
{
    int sts;
    SYSTEMTIME systemtime;
    FILETIME utime;

    GetSystemTime(&systemtime);
    sts = SystemTimeToFileTime(&systemtime,&utime); // UTC SystemTime -> UTC FileTime
    ((ULARGE_INTEGER*)x)->LowPart = utime.dwLowDateTime;
    ((ULARGE_INTEGER*)x)->HighPart = utime.dwHighDateTime;
    return sts;
}

static VOID cbsetsub(HWND hWnd,int cb,LPTSTR buf)
{
    int sts;

    sts = SendDlgItemMessage(hWnd, cb, CB_FINDSTRINGEXACT, -1, (LONG)buf);
/*dbgprintf(_T("LINE=%d sts=%d"),__LINE__,sts);
*/
    if ( sts == CB_ERR ) {
        sts = SendDlgItemMessage(hWnd, cb, CB_INSERTSTRING, 0, (LONG)buf);
/*dbgprintf(_T("LINE=%d sts=%d buf=%s"),__LINE__,sts,buf);
*/
    } 
}

__int64 starttime;
__int64 endtime;
__int64 timecount;

/*
IDOK:  Jn(&S)
*/
static VOID startjob(HWND hWnd)
{
/*
short zzz1 = 0xba1;
*/
static _TCHAR buf[LONGMAX_PATH + 1];
/*
short zzz2 = 0xba2;
*/
    int sts;
    _TCHAR *errmsg;
    _TCHAR flag1[13];
    _TCHAR *flage;


LOG dfdlog("LINE=%d startjob(HWND hWnd=%d)",__LINE__,hWnd);
/*
_ASSERT( zzz1 == 0xba1 && zzz2 == 0xba2 );
*/
    if ( threaddata.threadhandle != 0 && threaddata.threadendflag == 0) {
LOG dfdlog("LINE=%d !startjob:threaddata.threadhandle=%d",__LINE__,threaddata.threadhandle);
/*
_ASSERT( zzz1 == 0xba1 && zzz2 == 0xba2 );
*/
        SetDlgItemText(hWnd, IDOLSTS, Alreadythread);
        return;
    }
    startup(hWnd,IDC_PROGRESS1);
    dragmode = 0;
    GetDlgItemText(hWnd, IDC_EDIT1, buf, (sizeof buf / sizeof buf[0]) - 1);
    if ( buf[0] == 0 ) {
        SetDlgItemText(hWnd, IDSTS, EmptyFolderName);
        return;
    }
    sts = setpath1(hWnd,buf,&errmsg);
    if ( sts ) return;
    GetDlgItemText(hWnd, IDC_EDIT2, buf, (sizeof buf / sizeof buf[0]) - 1);
    if ( buf[0] == 0 ) {
        SetDlgItemText(hWnd, IDSTS, EmptyFolderName);
        return;
    }
    sts = setpath2(hWnd,buf,&errmsg);
    if ( sts ) return;
    cbsetsub(hWnd,IDC_EDIT2,buf);
    GetDlgItemText(hWnd, IDC_EDIT1, buf, (sizeof buf / sizeof buf[0]) - 1);
    cbsetsub(hWnd,IDC_EDIT2,buf);
    cbsetsub(hWnd,IDC_EDIT1,buf);
    GetDlgItemText(hWnd, IDC_EDIT2, buf, (sizeof buf / sizeof buf[0]) - 1);
    cbsetsub(hWnd,IDC_EDIT1,buf);
    GetDlgItemText(hWnd, IDC_MODE, buf, (sizeof buf / sizeof buf[0]) - 1);
    if ( buf[0] >= '1' && buf[0] <= '4' ) prio = buf[0] - '0';
/*dbgprintf(_T("IDC_MODE='%s' prio=%d)"),buf,prio);
*/
    settime(&starttime);
    flag1[0] = 0;
    if ( IsDlgButtonChecked(hWnd,IDC_RADIO1) == BST_CHECKED ) {
        ;
    } else if ( IsDlgButtonChecked(hWnd,IDC_RADIO2) == BST_CHECKED ) {
        setflag(sizeof flag1 / sizeof flag1[0],flag1,'s');
    } else if ( IsDlgButtonChecked(hWnd,IDC_RADIO3) == BST_CHECKED ) {
        setflag(sizeof flag1 / sizeof flag1[0],flag1,'d');
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK1) == BST_CHECKED ) {
        setflag(sizeof flag1 / sizeof flag1[0],flag1,'r');
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK2) == BST_CHECKED ) {
        setflag(sizeof flag1 / sizeof flag1[0],flag1,'z');
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK3) == BST_CHECKED ) {
        setflag(sizeof flag1 / sizeof flag1[0],flag1,'t');
    }
    GetDlgItemText(hWnd, IDC_EDIT3, buf, (sizeof buf / sizeof buf[0]) - 1);
    if ( buf[0] != 0 && IsDlgButtonChecked(hWnd,IDC_CHECK4) == BST_CHECKED ) {
        flage = malloc((_tcslen(buf) + 3) * sizeof(_TCHAR));
        _tcscpy(flage,buf);
    } else {
        flage = NULL;
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK5) == BST_CHECKED ) {
        setflag(sizeof flag1 / sizeof flag1[0],flag1,'n');
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK6) == BST_CHECKED ) {
        setflag(sizeof flag1 / sizeof flag1[0],flag1,'p');
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK7) == BST_CHECKED ) {
        setflag(sizeof flag1 / sizeof flag1[0],flag1,'q');
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK8) == BST_CHECKED ) {
        setflag(sizeof flag1 / sizeof flag1[0],flag1,'a');
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK9) == BST_CHECKED ) {
        setflag(sizeof flag1 / sizeof flag1[0],flag1,'i');
    }
    setflags(flag1,flage);
    if ( flage ) free(flage);
    stopflag = 0;
#if 0
    sts = SendMessage(      // returns LRESULT in lResult
         GetDlgItem(hWnd,IDC_PROGRESS1), // handle to destination control
         (UINT)PBM_SETPOS,      // message ID
         (WPARAM)0,      // = (WPARAM) (int) nNewPos;
         (LPARAM)0      // = 0; not used, must be zero
        );
    SetDlgItemText(hWnd, IDOLSTS, _T(""));
    SetDlgItemText(hWnd, IDNUMBERS, _T(""));
#else
    percent(_T(""),-1);
#endif
    SetDlgItemText(hWnd, IDSTS, _T(""));
LOG dfdlog("LINE=%d call startthread()",__LINE__);
    sts = startthread(hWnd,&errmsg);
    if ( sts ) {
        SetDlgItemText(hWnd, IDSTS, errmsg);
        return;
    }
/*
    EnableWindow(GetDlgItem(hWnd, IDC_EDIT1), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_BUTTON1), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_EDIT2), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_BUTTON2), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_RADIO1), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_RADIO2), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_RADIO3), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK1), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK2), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK3), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK4), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK5), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK6), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK7), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK8), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK9), FALSE);
*/
    EnableWindow(GetDlgItem(hWnd, IDOK), FALSE);
    EnableWindow(GetDlgItem(hWnd, IDABORT), TRUE);
    hcur0 = LoadCursor(NULL, IDC_WAIT);
    hcur = SetCursor(hcur0);
/*dbgprintf(_T("hcur=%d hcur0=%d"),hcur,hcur0);
*/
    return;
}

int deletemode;

/*
WM_APP + 0x0100
*/
static VOID exitjob(HWND hWnd)
{
    int sts;
    _TCHAR *errmsg;
    DWORD wait;
    DWORD exitcode = 0;
static _TCHAR szCurDir[LONGMAX_PATH + 1];

LOG dfdlog("LINE=%d exitjob(HWND hWnd=%d) threaddata.threadid=%d",__LINE__,hWnd,threaddata.threadid);

    settime(&endtime);
    timecount = (endtime - starttime) / 10000000;
    if ( threaddata.threadid != 0 ) {
        wait = WaitForSingleObject((HANDLE)threaddata.threadhandle,20000);
LOG dfdlog("LINE=%d WaitForSingleObject((HANDLE)threaddata.threadhandle=%d,20000)=%d",__LINE__,threaddata.threadid,wait);
        if ( wait == WAIT_TIMEOUT ) {
            sts = MessageBox(hWnd,_T("Thread did not stop in 20 seconds."),pgname0,MB_OK | MB_ICONERROR);
        }
    }
    sts = GetExitCodeThread((HANDLE)threaddata.threadhandle,&exitcode);
LOG dfdlog("LINE=%d GetExitCodeThread((HANDLE)threaddata.threadhandle=%d,&exitcode=%d)=%d",__LINE__,threaddata.threadid,exitcode,sts);
    if ( sts ) {
        if ( exitcode == STILL_ACTIVE ) {
            stopflag = 1;
            sts_printf(NULL,_T("Error: GetExitCodeThread() STILL_ACTIVE\n"));
            sts = MessageBox(hWnd,_T("Error: GetExitCodeThread() STILL_ACTIVE"),pgname0,MB_OK | MB_ICONERROR);
        }
        threaddata.exitcode = exitcode;
    } else {
        sts_printf(NULL,_T("Error: GetExitCodeThread()=%d\n"),GetLastError());
        sts = MessageBox(hWnd,_T("Error: GetExitCodeThread()"),pgname0,MB_OK | MB_ICONERROR);
    }
    sts = closethread(hWnd,&errmsg);
    if ( sts ) {
        SetDlgItemText(hWnd, IDOLSTS, errmsg);
        return;
    }
    if ( stopflag == 0 ) {
        if ( exitcode != 3 ) {
            if ( exitcode != 54 ) {
                _stprintf(szCurDir,EndJob,timecount);
                SetDlgItemText(hWnd, IDOLSTS, szCurDir);
            }
            SetDlgItemText(hWnd, IDPERCENT, _T(""));
            sts = SendMessage(      // returns LRESULT in lResult
                 GetDlgItem(hWnd,IDC_PROGRESS1), // handle to destination control
                 (UINT) PBM_SETPOS,      // message ID
                 (WPARAM) 0,      // = (WPARAM) (int) nNewPos;
                 (LPARAM) 0      // = 0; not used, must be zero
                 );
        }
    }
    if ( deletemode != 1 ) {
        CheckDlgButton(hWnd, IDC_CHECK7, BST_UNCHECKED);
        CheckRadioButton(hWnd, IDC_RADIO1, IDC_RADIO3, IDC_RADIO1);
    }
    SetCursor(hcur);
    EnableWindow(GetDlgItem(hWnd, IDC_EDIT1), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_BUTTON1), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_EDIT2), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_BUTTON2), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_RADIO1), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_RADIO2), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_RADIO3), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK1), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK2), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK3), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK4), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_EDIT3), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK5), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK6), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK7), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK8), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDC_CHECK9), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDOK), TRUE);
    EnableWindow(GetDlgItem(hWnd, IDABORT), FALSE);
    SetFocus(hWnd);
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK10) == BST_CHECKED && exitcode != 54 ) {
        GetCurrentDirectory(sizeof(szCurDir), szCurDir);
        viewdoc(hWnd,_T("dfdlog.txt"),szCurDir);
    }
    return;
}

/*
IDM_EXIT
IDCANCEL:  (&C)
WM_CLOSE
WM_DESTROY
*/
static VOID stopjob(HWND hWnd)
{
    int sts;
    _TCHAR *errmsg;
    DWORD wait;
static _TCHAR msgbuff[LONGMAX_PATH + 1];
static _TCHAR msgbox[LONGMAX_PATH + 1];
    DWORD msec;

/*dbgprintf(_T("stopjob(HWND hWnd=%d)"),hWnd);
*/
    GetDlgItemText(hWnd, IDC_EDIT3, msgbuff, (sizeof msgbuff / sizeof msgbuff[0]) - 1);
    setinikey(NULL,_T("options"),_T("extensions"),msgbuff);
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK1) == BST_CHECKED ) {
        setinikey(NULL,_T("options"),_T("removereadonly"),_T("1"));
    } else {
        setinikey(NULL,_T("options"),_T("removereadonly"),_T("0"));
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK2) == BST_CHECKED ) {
        setinikey(NULL,_T("options"),_T("removemode"),_T("1"));
    } else {
        setinikey(NULL,_T("options"),_T("removemode"),_T("0"));
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK3) == BST_CHECKED ) {
        setinikey(NULL,_T("options"),_T("timestamp"),_T("1"));
    } else {
        setinikey(NULL,_T("options"),_T("timestamp"),_T("0"));
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK4) == BST_CHECKED ) {
        setinikey(NULL,_T("options"),_T("extensiononly"),_T("1"));
    } else {
        setinikey(NULL,_T("options"),_T("extensiononly"),_T("0"));
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK8) == BST_CHECKED ) {
        setinikey(NULL,_T("options"),_T("logappend"),_T("1"));
    } else {
        setinikey(NULL,_T("options"),_T("logappend"),_T("0"));
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK9) == BST_CHECKED ) {
        setinikey(NULL,_T("options"),_T("compare"),_T("1"));
    } else {
        setinikey(NULL,_T("options"),_T("compare"),_T("0"));
    }
    if ( IsDlgButtonChecked(hWnd,IDC_CHECK10) == BST_CHECKED ) {
        setinikey(NULL,_T("options"),_T("display"),_T("1"));
    } else {
        setinikey(NULL,_T("options"),_T("display"),_T("0"));
    }
    if ( threaddata.threadid != 0 ) {
        stopflag = 1;
        EnableWindow(GetDlgItem(hWnd, IDABORT), FALSE);
        EnableWindow(GetDlgItem(hWnd, IDCANCEL), FALSE);
        SetDlgItemText(hWnd, IDOLSTS, Abortthread);
        msec = 20000 + tocount[prio];
        wait = WaitForSingleObject((HANDLE)threaddata.threadhandle,msec);
        if ( wait == WAIT_TIMEOUT ) {
            _stprintf(msgbox,_T("Thread did not stop in %d seconds."),msec / 1000);
            sts = MessageBox(hWnd,msgbox,pgname0,MB_OK | MB_ICONERROR);
            wait = WaitForSingleObject((HANDLE)threaddata.threadhandle,200);
            if ( wait != WAIT_TIMEOUT ) {
                sts = CloseHandle((HANDLE)threaddata.threadhandle);
            }
        }
        EnableWindow(GetDlgItem(hWnd, IDABORT), TRUE);
        EnableWindow(GetDlgItem(hWnd, IDCANCEL), TRUE);
    }
    if ( stopflag == 0 ) {
        sts = fixup(hWnd,&errmsg);
        if ( sts ) {
            sts_printf(NULL,_T("%s"),errmsg);
/*
            SetDlgItemText(hWnd, IDSTS, errmsg);
*/
        }
    }
    return;
}

/*
IDABORT:   f(&A) 
*/
static VOID abortjob(HWND hWnd)
{
    int sts;
    _TCHAR *errmsg;

/*dbgprintf(_T("abortjob(HWND hWnd=%d)"),hWnd);
*/
    stopflag = 1;
    EnableWindow(GetDlgItem(hWnd, IDABORT), FALSE);
/*
    sts_printf(NULL,_T("%s"),Abortthread);
*/
    SetDlgItemText(hWnd, IDOLSTS, Abortthread);
    return;
}

RECT sDlg;
RECT cDlg;
#if 0
#endif
RECT RectEdit1;
RECT RectEdit2;
RECT sRectEdit1;
RECT sRectEdit2;

int dragfile(HWND hWnd, HDROP hDrop)
{
static _TCHAR buf[LONGMAX_PATH + 1];
    int iFile;
    int count;
    int n;
    BOOL sts;
    POINT pt;
    POINT cpt;
    LONG x;
    LONG y;
    POINT spt;
    POINT s1pt;
    POINT s2pt;
    _TCHAR *dir;

/*dbgprintf(_T("dragmode=%d dragfile(HWND hWnd=%d, HDROP hDrop=%d)"),dragmode,hWnd,hDrop);
*/
    sts = GetClientRect(hWnd,&cDlg);
/*dbgprintf(_T("GetClientRect(hWnd=%d, &cDlg)=0x%x cDlg.left=%ld cDlg.top=%ld cDlg.right=%ld cDlg.bottom=%ld"),hWnd, sts, cDlg.left, cDlg.top, cDlg.right, cDlg.bottom);
*/
    sts = GetWindowRect(hWnd,&sDlg);
/*dbgprintf(_T("GetWindowRect(hWnd=%d, &sDlg)=0x%x sDlg.left=%ld sDlg.top=%ld sDlg.right=%ld sDlg.bottom=%ld"),hWnd, sts, sDlg.left, sDlg.top, sDlg.right, sDlg.bottom);
*/
#if 0
#endif
#if 0
    sts = GetClientRect(GetDlgItem(hWnd, IDC_EDIT1),&RectEdit1);
/*dbgprintf(_T("GetClientRect(GetDlgItem(hWnd=%d, IDC_EDIT1=%d)=%d, &RectEdit1)=0x%x RectEdit1.left=%ld RectEdit1.top=%ld RectEdit1.right=%ld RectEdit1.bottom=%ld"),hWnd, IDC_EDIT1, GetDlgItem(hWnd, IDC_EDIT1), sts, RectEdit1.left, RectEdit1.top, RectEdit1.right, RectEdit1.bottom);
*/
#endif
    sts = GetWindowRect(GetDlgItem(hWnd, IDC_EDIT1),&RectEdit1);
/*dbgprintf(_T("GetWindowRect(GetDlgItem(hWnd=%d, IDC_EDIT1=%d)=%d, &RectEdit1)=0x%x RectEdit1.left=%ld RectEdit1.top=%ld RectEdit1.right=%ld RectEdit1.bottom=%ld"),hWnd, IDC_EDIT1, GetDlgItem(hWnd, IDC_EDIT1), sts, RectEdit1.left, RectEdit1.top, RectEdit1.right, RectEdit1.bottom);
*/
#if 0
    sts = GetClientRect(GetDlgItem(hWnd, IDC_EDIT2),&RectEdit2);
/*dbgprintf(_T("GetClientRect(GetDlgItem(hWnd=%d, IDC_EDIT2=%d)=%d, &RectEdit2)=0x%x RectEdit2.left=%ld RectEdit2.top=%ld RectEdit2.right=%ld RectEdit2.bottom=%ld"),hWnd, IDC_EDIT2, GetDlgItem(hWnd, IDC_EDIT2), sts, RectEdit2.left, RectEdit2.top, RectEdit2.right, RectEdit2.bottom);
*/
#endif
    sts = GetWindowRect(GetDlgItem(hWnd, IDC_EDIT2),&RectEdit2);
/*dbgprintf(_T("GetWindowRect(GetDlgItem(hWnd=%d, IDC_EDIT2=%d)=%d, &RectEdit2)=0x%x RectEdit2.left=%ld RectEdit2.top=%ld RectEdit2.right=%ld RectEdit2.bottom=%ld"),hWnd, IDC_EDIT2, GetDlgItem(hWnd, IDC_EDIT2), sts, RectEdit2.left, RectEdit2.top, RectEdit2.right, RectEdit2.bottom);
*/
    n = DragQueryFile(hDrop, 0xFFFFFFFF, NULL, sizeof buf);
    for ( iFile = 0 ; iFile < n ; iFile++) {
        count = DragQueryFile(hDrop, iFile, buf, sizeof buf);
/*dbgprintf(_T("DragQueryFile(hDrop=%d, iFile=%d, buf=%s)=%d"),hDrop,iFile,buf,count);
*/
        sts = DragQueryPoint(hDrop, &pt);
/*dbgprintf(_T("DragQueryPoint(hDrop=%d)=%d pt.x=%ld pt.y=%ld"),hDrop,sts,pt.x,pt.y);
*/
#if 0
        cpt.x = pt.x;
        cpt.y = pt.y;
        sts = ScreenToClient(hWnd,&cpt);
/*dbgprintf(_T("ScreenToClient(hWnd=%d,cpt.x=%ld,cpt.y=%ld)=%d"),hDrop,cpt.x,cpt.y,sts);
*/
#endif
        spt.x = pt.x;
        spt.y = pt.y;
        sts = ClientToScreen(hWnd,&spt);
/*dbgprintf(_T("ClientToScreen(hWnd=%d,spt.x=%ld,spt.y=%ld)=%d"),hDrop,spt.x,spt.y,sts);
*/
        x = spt.x;
        y = spt.y;
/*dbgprintf(_T("x=%ld, y=%ld"),x, y);
*/

#if 0
        spt.x = RectEdit1.left;
        spt.y = RectEdit1.top;
        sts = ClientToScreen(hWnd,&spt);
        sRectEdit1.left = spt.x;
        sRectEdit1.top = spt.y;
/*dbgprintf(_T("ClientToScreen(hWnd=%d,spt.x=%ld,spt.y=%ld)=%d"),hDrop,spt.x,spt.y,sts);
*/
        spt.x = RectEdit1.right;
        spt.y = RectEdit1.bottom;
        sts = ClientToScreen(hWnd,&spt);
        sRectEdit1.right = spt.x;
        sRectEdit1.bottom = spt.y;
/*dbgprintf(_T("ClientToScreen(hWnd=%d,spt.x=%ld,spt.y=%ld)=%d"),hDrop,spt.x,spt.y,sts);
*/
        spt.x = RectEdit2.left;
        spt.y = RectEdit2.top;
        sts = ClientToScreen(hWnd,&spt);
        sRectEdit2.left = spt.x;
        sRectEdit2.top = spt.y;
/*dbgprintf(_T("ClientToScreen(hWnd=%d,spt.x=%ld,spt.y=%ld)=%d"),hDrop,spt.x,spt.y,sts);
*/
        spt.x = RectEdit2.right;
        spt.y = RectEdit2.bottom;
        sts = ClientToScreen(hWnd,&spt);
        sRectEdit2.right = spt.x;
        sRectEdit2.bottom = spt.y;
/*dbgprintf(_T("ClientToScreen(hWnd=%d,spt.x=%ld,spt.y=%ld)=%d"),hDrop,spt.x,spt.y,sts);
*/
#endif
/*dbgprintf(_T("RectEdit1.left=%ld, x=%ld RectEdit1.right=%d RectEdit1.top=%ld, y=%ld RectEdit1.bottom=%d"), RectEdit1.left, x, RectEdit1.right, RectEdit1.top, y, RectEdit1.bottom);
*/
/*dbgprintf(_T("RectEdit2.left=%ld, x=%ld RectEdit2.right=%d RectEdit2.top=%ld, y=%ld RectEdit2.bottom=%d"), RectEdit2.left, x, RectEdit2.right, RectEdit2.top, y, RectEdit2.bottom);
*/
#if 0
/*dbgprintf(_T("sRectEdit1.left=%ld, x=%ld sRectEdit1.right=%d sRectEdit1.top=%ld, y=%ld sRectEdit1.bottom=%d"), sRectEdit1.left, x, sRectEdit1.right, sRectEdit1.top, y, sRectEdit1.bottom);
*/
/*dbgprintf(_T("sRectEdit2.left=%ld, x=%ld sRectEdit2.right=%d sRectEdit2.top=%ld, y=%ld sRectEdit2.bottom=%d"), sRectEdit2.left, x, sRectEdit2.right, sRectEdit2.top, y, sRectEdit2.bottom);
*/
#endif

        if ( RectEdit1.left <= x && x <= RectEdit1.right && RectEdit1.top <= y && y <= RectEdit1.bottom ) {
/*dbgprintf(_T("RectEdit1: x=%ld, y=%ld)=%d"), x, y,sts);
*/
            dir = truepath(buf);
            SetDlgItemText(hWnd, IDC_EDIT1, dir);
            free(dir);
            dragmode = 1;
        } else if ( RectEdit2.left <= x && x <= RectEdit2.right && RectEdit2.top <= y && y <= RectEdit2.bottom ) {
/*dbgprintf(_T("RectEdit2: x=%ld, y=%ld)=%d"), x, y,sts);
*/
            dir = truepath(buf);
            SetDlgItemText(hWnd, IDC_EDIT2, dir);
            free(dir);
            dragmode = 0;
        } else {
            if ( dragmode == 0 ) {
                dir = truepath(buf);
                SetDlgItemText(hWnd, IDC_EDIT1, dir);
                free(dir);
                dragmode = 1;
            } else if ( dragmode == 1 ) {
                dir = truepath(buf);
                SetDlgItemText(hWnd, IDC_EDIT2, dir);
                free(dir);
                dragmode = 0;
            }
        }
    }
    DragFinish(hDrop);
    return 0;
}

#if 0
int notify(HWND hWnd, int wParam, LPNMHDR lParam)
{

/*dbgprintf(_T("notify(HWND hWnd=%d, int wParam=%d, LPNMHDR lParam=%p)"),hWnd,wParam,lParam);
*/
    switch ( lParam->code ) {
        case EN_MSGFILTER:
            //肽
            break;
    }
    return 0;
}
#endif

static VOID OnInitDialog(HWND hWnd)
{
    _TCHAR *p;
    _TCHAR *q;
    LRESULT dwEvent;
    LRESULT dwEvent2;
    BOOL sts;
    POINT pt;
    int i;
    int start;

/*dbgprintf(_T("OnInitDialog(HWND hWnd=%d)"),hWnd);
*/
    SetDlgItemText(hWnd, IDOLSTS, Version);
    SetDlgItemText(hWnd, IDSTS, Initmsg);
    CheckRadioButton(hWnd, IDC_RADIO1, IDC_RADIO3, IDC_RADIO1);
//    CheckDlgButton(hWnd, IDC_CHECK10, BST_CHECKED);
    p = getinikey(NULL,_T("history0"),_T("source"));
    if ( p != NULL && *p != 0 ) {
        SetDlgItemText(hWnd, IDC_EDIT1, p);
    }
    cbsetsub(hWnd,IDC_EDIT1,p);
    p = getinikey(NULL,_T("history0"),_T("destination"));
    if ( p != NULL && *p != 0 ) {
        SetDlgItemText(hWnd, IDC_EDIT2, p);
    }
    cbsetsub(hWnd,IDC_EDIT2,p);

// ΂̃R{{bNXɂ
    cbsetsub(hWnd,IDC_EDIT1,p);
    p = getinikey(NULL,_T("history0"),_T("source"));
    if ( p != NULL && *p != 0 ) {
        SetDlgItemText(hWnd, IDC_EDIT1, p);
    }
    cbsetsub(hWnd,IDC_EDIT2,p);

    p = getinikey(NULL,_T("options"),_T("removereadonly"));
    if ( p != NULL && *p != 0 ) {
        if ( *p == '1' ) {
            CheckDlgButton(hWnd, IDC_CHECK1, BST_CHECKED);
        }
    }
    p = getinikey(NULL,_T("options"),_T("removemode"));
    if ( p != NULL && *p != 0 ) {
        if ( *p == '1' ) {
            CheckDlgButton(hWnd, IDC_CHECK2, BST_CHECKED);
        }
    }
    p = getinikey(NULL,_T("options"),_T("timestamp"));
    if ( p != NULL && *p != 0 ) {
        if ( *p == '1' ) {
            CheckDlgButton(hWnd, IDC_CHECK3, BST_CHECKED);
        }
    }
    p = getinikey(NULL,_T("options"),_T("extensiononly"));
    if ( p != NULL && *p != 0 ) {
        if ( *p == '1' ) {
            CheckDlgButton(hWnd, IDC_CHECK4, BST_CHECKED);
        }
    }
    p = getinikey(NULL,_T("options"),_T("extensions"));
    if ( p != NULL && *p != 0 ) {
        SetDlgItemText(hWnd, IDC_EDIT3, p);
    }
    p = getinikey(NULL,_T("options"),_T("logappend"));
    if ( p != NULL && *p != 0 ) {
        if ( *p == '1' ) {
            CheckDlgButton(hWnd, IDC_CHECK8, BST_CHECKED);
        }
    }
    p = getinikey(NULL,_T("options"),_T("compare"));
    if ( p != NULL && *p != 0 ) {
        if ( *p == '1' ) {
            CheckDlgButton(hWnd, IDC_CHECK9, BST_CHECKED);
        }
    }
    p = getinikey(NULL,_T("options"),_T("display"));
    if ( p != NULL && *p != 0 ) {
        if ( *p == '1' ) {
            CheckDlgButton(hWnd, IDC_CHECK10, BST_CHECKED);
        }
    }
    p = getinikey(NULL,_T("options"),_T("deletemode"));
    if ( p != NULL && *p != 0 ) {
        if ( _tcscmp(p,_T("Unsafe")) == 0 ) {
            deletemode = 1;
        } else {
            deletemode = 1;
        }
    }
/*
@
*/
    p = Priority;
    do {
        if ( q = _tcschr(p,'|') ) {
            *q = 0;
        }
        SendDlgItemMessage(hWnd, IDC_MODE, CB_ADDSTRING, 0, (LONG)p);
        p = q + 1;
    } while ( q );
#ifdef DEBUG
SetDlgItemText(hWnd, IDPERCENT, _T("DEBUG"));
// SetDlgItemText(hWnd, IDNUMBERS, _T("1234567890abcdefghijklmnopqrstuvwxyz"));
#endif
#if 0
    dwEvent = SendMessage( // returns LRESULT in lResult
      /*GetDlgItem(*/ hWnd /*, IDC_EDIT1) */,  // handle to destination control
      (UINT) EM_GETEVENTMASK,    // message ID
      (WPARAM) 0,     // This parameter is not used; it must be zero.
      (LPARAM) 0
    );
/*dbgprintf(_T("SendMessage(hWnd=%d, EM_GETEVENTMASK=%d, 0=0x%x)=0x%x"),hWnd, EM_GETEVENTMASK, 0, dwEvent);
*/
    dwEvent2 = SendMessage( // returns LRESULT in lResult
      /*GetDlgItem(*/ hWnd /*, IDC_EDIT1) */,  // handle to destination control
      (UINT) EM_SETEVENTMASK,    // message ID
      (WPARAM) 0,     // This parameter is not used; it must be zero.
      (LPARAM) dwEvent | ENM_DROPFILES   // New event mask for the rich edit control. For a list of event masks, see Rich Edit Control Event Mask Flags. 
      );
/*dbgprintf(_T("SendMessage(hWnd=%d, EM_SETEVENTMASK=%d, dwEvent | ENM_DROPFILES=0x%x)=0x%x"),hWnd, EM_SETEVENTMASK, dwEvent | ENM_DROPFILES, dwEvent2);
*/
#endif
#if 0
    dwEvent = SendMessage( // returns LRESULT in lResult
      GetDlgItem(hWnd , IDC_EDIT1),  // handle to destination control
      (UINT) EM_GETEVENTMASK,    // message ID
      (WPARAM) 0,     // This parameter is not used; it must be zero.
      (LPARAM) 0
    );
/*dbgprintf(_T("SendMessage(GetDlgItem(hWnd=%d, IDC_EDIT1=%d)=%d, EM_GETEVENTMASK=%d, 0=0x%x)=0x%x"),hWnd, IDC_EDIT1, GetDlgItem(hWnd, IDC_EDIT1), EM_GETEVENTMASK, 0, dwEvent);
*/
    dwEvent2 = SendMessage( // returns LRESULT in lResult
      GetDlgItem(hWnd, IDC_EDIT1),  // handle to destination control
      (UINT) EM_SETEVENTMASK,    // message ID
      (WPARAM) 0,     // This parameter is not used; it must be zero.
      (LPARAM) dwEvent | ENM_DROPFILES   // New event mask for the rich edit control. For a list of event masks, see Rich Edit Control Event Mask Flags. 
      );
/*dbgprintf(_T("SendMessage(GetDlgItem(hWnd=%d, IDC_EDIT1=%d)=%d, EM_SETEVENTMASK=%d, dwEvent | ENM_DROPFILES=0x%x)=0x%x"),hWnd, IDC_EDIT1, GetDlgItem(hWnd, IDC_EDIT1), EM_SETEVENTMASK, dwEvent | ENM_DROPFILES, dwEvent2);
*/
    dwEvent2 = SendMessage( // returns LRESULT in lResult
      GetDlgItem(hWnd , IDC_EDIT1),  // handle to destination control
      (UINT) EM_GETEVENTMASK,    // message ID
      (WPARAM) 0,     // This parameter is not used; it must be zero.
      (LPARAM) 0
    );
/*dbgprintf(_T("SendMessage(GetDlgItem(hWnd=%d, IDC_EDIT1=%d)=%d, EM_GETEVENTMASK=%d, 0=0x%x)=0x%x"),hWnd, IDC_EDIT1, GetDlgItem(hWnd, IDC_EDIT1), EM_GETEVENTMASK, 0, dwEvent2);
*/
    dwEvent = SendMessage( // returns LRESULT in lResult
      GetDlgItem(hWnd, IDC_EDIT2),  // handle to destination control
      (UINT) EM_GETEVENTMASK,    // message ID
      (WPARAM) 0,     // This parameter is not used; it must be zero.
      (LPARAM) 0
    );
/*dbgprintf(_T("SendMessage(GetDlgItem(hWnd=%d, IDC_EDIT2=%d)=%d, EM_GETEVENTMASK=%d, 0=0x%x)=0x%x"),hWnd, IDC_EDIT2, GetDlgItem(hWnd, IDC_EDIT2), EM_GETEVENTMASK, 0, dwEvent);
*/
    dwEvent2 = SendMessage( // returns LRESULT in lResult
      GetDlgItem(hWnd, IDC_EDIT2),  // handle to destination control
      (UINT) EM_SETEVENTMASK,    // message ID
      (WPARAM) 0,     // This parameter is not used; it must be zero.
      (LPARAM) dwEvent | ENM_DROPFILES   // New event mask for the rich edit control. For a list of event masks, see Rich Edit Control Event Mask Flags. 
      );
/*dbgprintf(_T("SendMessage(GetDlgItem(hWnd=%d, IDC_EDIT2=%d)=%d, EM_SETEVENTMASK=%d, dwEvent | ENM_DROPFILES=0x%x)=0x%x"),hWnd, IDC_EDIT2, GetDlgItem(hWnd, IDC_EDIT2), EM_SETEVENTMASK, dwEvent | ENM_DROPFILES, dwEvent2);
*/
    dwEvent2 = SendMessage( // returns LRESULT in lResult
      GetDlgItem(hWnd, IDC_EDIT2),  // handle to destination control
      (UINT) EM_GETEVENTMASK,    // message ID
      (WPARAM) 0,     // This parameter is not used; it must be zero.
      (LPARAM) 0
    );
/*dbgprintf(_T("SendMessage(GetDlgItem(hWnd=%d, IDC_EDIT2=%d)=%d, EM_GETEVENTMASK=%d, 0=0x%x)=0x%x"),hWnd, IDC_EDIT2, GetDlgItem(hWnd, IDC_EDIT2), EM_GETEVENTMASK, 0, dwEvent2);
*/
    DragAcceptFiles(
    GetDlgItem(hWnd, IDC_EDIT1), // EBhẼnh
    TRUE // 󂯓̗L
    );
    DragAcceptFiles(
    GetDlgItem(hWnd, IDC_EDIT2), // EBhẼnh
    TRUE // 󂯓̗L
    );
#endif
    DragAcceptFiles(
    hWnd, // EBhẼnh
    TRUE // 󂯓̗L
    );
    EnableWindow(GetDlgItem(hWnd, IDABORT), FALSE);
    return;
}

HINSTANCE g_hInst;

INT_PTR CALLBACK DlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    HICON hIcon;
static _TCHAR buf[LONGMAX_PATH + 1];

/*dbgprintf(_T("DlgProc message=%d wParam=%d lParam=%d"),message,wParam,lParam);
*/
    switch ( message ) {
      case WM_INITDIALOG: /* _CAȌ */
/*dbgprintf(_T("WM_INITDIALOG=%d"),WM_INITDIALOG);
*/
/*
        hIcon = LoadIcon(NULL, MAKEINTRESOURCE(IDI_APP));
        SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
        SendMessage(hWnd, WM_SETICON, ICON_BIG, (LPARAM)hIcon);
http://support.microsoft.com/kb/179582
*/
        hIcon = LoadImage( g_hInst,
                           MAKEINTRESOURCE(IDR_MAINFRAME),
                           IMAGE_ICON,
                           GetSystemMetrics(SM_CXSMICON),
                           GetSystemMetrics(SM_CYSMICON),
                           0);
        if ( hIcon ) {
            SendMessage(hWnd, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
            SendMessage(hWnd, WM_SETICON, ICON_BIG, (LPARAM)hIcon);
        }
/*dbgprintf(_T("IDR_MAINFRAME=%d MAKEINTRESOURCE(IDR_MAINFRAME)=%d hIcon=%d"),IDR_MAINFRAME,MAKEINTRESOURCE(IDR_MAINFRAME),hIcon);
*/
        OnInitDialog(hWnd);
        return TRUE;
      case WM_COMMAND:
/*dbgprintf(_T("WM_COMMAND=%d"),WM_COMMAND);
*/
/*dbgprintf(_T("LOWORD(wParam)=%d"),LOWORD(wParam));
*/
        switch ( LOWORD(wParam) ) {
          case IDM_EXIT:
/*dbgprintf(_T("IDM_EXIT=%d"),IDM_EXIT);
*/
            stopjob(hWnd);
            PostQuitMessage(0);
            return TRUE;
          case IDM_VERSION:
/*dbgprintf(_T("IDM_VERSION=%d"),IDM_VERSION);
*/
            MessageBox(hWnd, Version, About, MB_OK);
            return TRUE;
          case IDC_BUTTON1:  /* Q(&B) {^NbN */
/*dbgprintf(_T("IDC_BUTTON1=%d"),IDC_BUTTON1);
*/
            GetDlgItemText(hWnd, IDC_EDIT1, buf, (sizeof buf / sizeof buf[0]) - 1);
            pdirname = seldir(hWnd,buf,SeldirName);
            if ( pdirname != NULL ) {
                SetDlgItemText(hWnd, IDC_EDIT1, pdirname);
            }
            return TRUE;
          case IDC_BUTTON2:  /* Q(&D) {^NbN */
/*dbgprintf(_T("IDC_BUTTON2=%d"),IDC_BUTTON2);
*/
            GetDlgItemText(hWnd, IDC_EDIT2, buf, (sizeof buf / sizeof buf[0]) - 1);
            pdirname = seldir(hWnd,buf,SeldirName2);
            if ( pdirname != NULL ) {
                SetDlgItemText(hWnd, IDC_EDIT2, pdirname);
            }
            return TRUE;
          case IDOK:  /* Jn(&S) {^NbN */
/*dbgprintf(_T("IDOK=%d"),IDOK);
*/
            startjob(hWnd);
            return TRUE;
          case IDCANCEL:  /* (&C) {^NbN */
/*dbgprintf(_T("IDCANCEL=%d"),IDCANCEL);
*/
            stopjob(hWnd);
            PostQuitMessage(progexitcode);
            return TRUE;
          case IDABORT:  /* f(&A) {^NbN */
/*dbgprintf(_T("IDABORT=%d"),IDABORT);
*/
            abortjob(hWnd);
            return TRUE;
        }
        break;
      case WM_CLOSE:
/*dbgprintf(_T("WM_CLOSE=%d"),WM_CLOSE);
*/
        stopjob(hWnd);
        DestroyWindow(hWnd);
        return TRUE;
      case WM_DESTROY:
/*dbgprintf(_T("WM_DESTROY=%d"),WM_DESTROY);
*/
        stopjob(hWnd);
        PostQuitMessage(progexitcode);
        return TRUE;
      case WM_APP + 0x0100:
/*dbgprintf(_T("WM_APP + 0x0100=%d"),WM_APP + 0x0100);
*/
        exitjob(hWnd);
        return TRUE;

/*FALSE */
      case WM_DROPFILES:
/*dbgprintf(_T("WM_DROPFILES=%d"),WM_DROPFILES);
*/
        dragfile(hWnd, (HDROP)wParam);
        return TRUE;
/*
      case WM_NOTIFY:
dbgprintf(_T("WM_NOTIFY=%d"),WM_NOTIFY);
        notify(hWnd, (int)wParam, (LPNMHDR)lParam);
        return TRUE;
*/
    }
    return FALSE;
}

#if 0
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

/*dbgprintf(_T("WndProc message=%d wParam=%d lParam=%d"),message,wParam,lParam);
*/
    switch ( message ) {
      case WM_COMMAND:
/*dbgprintf("WM_COMMAND=%d\n",WM_COMMAND);
*/
/*dbgprintf("LOWORD(wParam)=%d\n",LOWORD(wParam));
*/
        switch ( LOWORD(wParam) ) {
          case IDM_EXIT:
/*dbgprintf("IDM_EXIT=%d\n",IDM_EXIT);
*/
            PostQuitMessage(0);
            return 0;
          case IDM_VERSION:
/*dbgprintf("IDM_VERSION=%d\n",IDM_VERSION);
*/
            MessageBox(hWnd, Version, About, MB_OK);
            return 0;
        }
        break;
      case WM_DESTROY:
/*dbgprintf("WM_DESTROY=%d\n",WM_DESTROY);
*/
        PostQuitMessage(0);
        return 0;
      case WM_NOTIFY:
/*dbgprintf(_T("WndProc() WM_NOTIFY=%d"),WM_NOTIFY);
*/
        notify(hWnd, (int)wParam, (LPNMHDR)lParam);
        return 0;
    }
    return DefWindowProc(hWnd, message, wParam, lParam);
}
#endif

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
    HWND hWnd;
    MSG msg;

#if 0
    WNDCLASSEX wc;
    ATOM wcatom;
#endif

    BOOL sts;

#if 0
LONG_PTR WindowProc;
#endif

LOG dfdlog("_tWinMain");

    g_hInst = hInstance;
    Version = loadstring(hInstance, String_Version);
    About = loadstring(hInstance, String_About);
    DialogName = loadstring(hInstance, String_DialogName);
    WindowName = loadstring(hInstance, String_WindowName);
    ClassName = loadstring(hInstance, String_ClassName);
    MenuName = loadstring(hInstance, String_MenuName);
    SeldirName = loadstring(hInstance, String_SeldirName);
    SeldirName2 = loadstring(hInstance, String_SeldirName2);
    EmptyFolderName = loadstring(hInstance, String_EmptyFolderName);
    CantCreateFolderName = loadstring(hInstance, String_CantCreateFolderName);
    Alreadythread = loadstring(hInstance, String_Alreadythread);
    Abortthread = loadstring(hInstance, String_Abortthread);
    Abortedthread = loadstring(hInstance, String_Abortedthread);
    Initmsg = loadstring(hInstance, String_Initmsg);
    EndJob = loadstring(hInstance, String_EndJob);
    ContAbort = loadstring(hInstance, String_ContAbort);
    Percent = loadstring(hInstance, String_Percent);
    Lock = loadstring(hInstance, String_Lock);
    Priority = loadstring(hInstance, String_Priority);
    Priority0 = loadstring(hInstance, String_Priority0);

#if 0
    wc.cbSize = sizeof(WNDCLASSEX);
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = (WNDPROC)WndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = DLGWINDOWEXTRA;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(NULL, MAKEINTRESOURCE(IDR_MAINFRAME));
    wc.hCursor = LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
    wc.hbrBackground = (HBRUSH)CreateSolidBrush(GetSysColor(COLOR_MENU));
    wc.lpszMenuName = NULL;
    wc.lpszClassName = TEXT("IDD_DIALOG");
    wc.hIconSm = NULL;
    wcatom = RegisterClassEx(&wc);
    if ( wcatom == 0 ) {
        lasterror = GetLastError();
        errprint(_T("RegisterClassEx() "));
        return 1;
    }
#endif

    progexitcode = 0;
    InitCommonControls();
    hWnd = CreateDialog(hInstance,  // W[̃nh
        DialogName,   // _CAO{bNXev[g
        NULL,      // I[i[EBhẼnh
        DlgProc /*NULL*/  // _CAO{bNXvV[W
        );
    if ( hWnd == NULL ) {
        lasterror = GetLastError();
        errprint(_T("CreateDialog(,%s,) err=%d "),DialogName,lasterror);
        return 1;
    }
    if ( globalalloc() ) {
        errprint(_T("inadequate memory.\n"),DialogName);
    }
    startup(hWnd,IDC_PROGRESS1);
    dragmode = 0;
    sts = ShowWindow(hWnd, nCmdShow);
    /* If the window was previously visible, the return value is nonzero. 
       If the window was previously hidden, the return value is zero. */
    sts = UpdateWindow(hWnd);
    /* If the function fails, the return value is zero. */

#if 0
    WindowProc = GetWindowLongPtr(hWnd, GWLP_WNDPROC);
/*dbgprintf(_T("GetWindowLongPtr(hWnd=%d, GWLP_WNDPROC=%d)=%p"),hWnd, GWLP_WNDPROC,WindowProc);
*/
    WindowProc = GetWindowLongPtr(hWnd, DWLP_DLGPROC);
/*dbgprintf(_T("GetWindowLongPtr(hWnd=%d, DWLP_DLGPROC=%d)=%p"),hWnd, DWLP_DLGPROC,WindowProc);
*/
#endif

    while ( (sts = GetMessage(&msg, NULL, 0, 0)) != 0 ) {
/*dbgprintf(_T("GetMessage(&msg, NULL, 0, 0))=%d"),sts);
*/
        if ( sts == -1 ) {
            lasterror = GetLastError();
            errprint(_T("GetMessage() "));
            return 1;
        } else {
            if ( IsDialogMessage(hWnd, &msg) ) continue;
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }
/*dbgprintf(_T("return msg.wParam=%d"),msg.wParam);
*/
    globalfree();
    return msg.wParam;
}
