/* Copyright (C) 2003-2008 VA007219 */
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <tchar.h>

int msgbox(HWND hWnd,UINT uType,_TCHAR *fmt, ...);

static _TCHAR fullav0[LONGMAX_PATH + 1];

static _TCHAR *fullpath(_TCHAR *av0)
{
    DWORD sts;

    sts = GetModuleFileName(NULL,fullav0,sizeof fullav0 / sizeof fullav0[0]);
    if ( sts == 0 ) {
#ifndef GUISUB
        _tprintf(_T("can't GetModuleFileName(NULL,,)\n"));
        exit(1);
#else
        msgbox(NULL,MB_OK | MB_ICONWARNING,_T("can't GetModuleFileName(NULL,,)"));
        PostQuitMessage(1);
#endif
    }
    return fullav0;
}

#ifdef _UNICODE
int dehex(_TUCHAR c)
{
    if ( c >= '0' && c <= '9' ) return c - '0';
    if ( c >= 'A' && c <= 'F' ) return c - 'A' + 10;
    if ( c >= 'a' && c <= 'f' ) return c - 'a' + 10;
    return 0;
}

void decode(_TUCHAR *buf,_TUCHAR *dest)
{
    _TUCHAR *p;
    _TUCHAR *q;
    _TUCHAR c;

    p = buf;
    q = dest;
    while ( *p ) {
        if ( *p != '%' ) {
            *q = *p;
        } else {
            p++;
            c = dehex(*p);
            p++;
            c = c * 16 + dehex(*p);
            p++;
            c = c * 16 + dehex(*p);
            p++;
            c = c * 16 + dehex(*p);
            *q = c;
        }
        p++;
        q++;
    }
    *q = 0;
}
#endif


/*}`Xbhł̓gps*/
_TCHAR *getinikey(_TCHAR *av0,_TCHAR *section,_TCHAR *key)
{
static _TCHAR ini[LONGMAX_PATH + 1];
#ifdef _UNICODE
static _TCHAR buf2[LONGMAX_PATH + 12];
    _TCHAR buf[LONGMAX_PATH * 5 + 12];
#else
static _TCHAR buf[LONGMAX_PATH + 12];
#endif

    _tcscpy(ini,fullpath(av0));
    _tcscpy(ini + _tcslen(ini) - 3,_T("ini"));
    GetPrivateProfileString(section,key,_T(""),buf,sizeof buf / sizeof buf[0],ini);
/*dbgprintf(_T("GetPrivateProfileString(section=%s,key=%s,_T()=%s,buf=%s,sizeof buf=%d,ini=%s)\n"),section,key,_T(""),buf,sizeof buf,ini);
*/
#ifdef _UNICODE
    decode(buf,buf2);
    return buf2;
#else
    return buf;
#endif
}

#ifdef _UNICODE
static _TUCHAR encbuf[LONGMAX_PATH * 5 + 12];

_TUCHAR enhex(_TUCHAR c)
{
static _TUCHAR x[] = _T("0123456789ABCDEF");

    return x[c & 0xf];
}

_TUCHAR *encode(_TUCHAR *buf)
{
    _TUCHAR *p;
    _TUCHAR *q;

    p = buf;
    q = encbuf;
    while ( *p ) {
        if ( *p < 128 && *p != '%' ) {
            *q = *p;
        } else {
            *q = '%';
            q++;
            *q = enhex(*p >> 12);
            q++;
            *q = enhex(*p >> 8);
            q++;
            *q = enhex(*p >> 4);
            q++;
            *q = enhex(*p);
        }
        p++;
        q++;
    }
    *q = 0;
    return encbuf;
}
#else
#define encode(x) x
#endif

void setinikey(_TCHAR *av0,_TCHAR *section,_TCHAR *key,_TCHAR *string)
{
    _TCHAR ini[65538];

    _tcscpy(ini,fullpath(av0));
    _tcscpy(ini + _tcslen(ini) - 3,_T("ini"));
    if ( _taccess(ini,02) == 0 ) {
        WritePrivateProfileString(section,key,encode(string),ini);
    }
    return ;
}

/*
int _tmain(int argc,_TCHAR **argv)
{

    setinikey(argv[0],_T("history0"),_T("source"),_T("c:\\"));
    _tprintf(_T("[%s]\n"),getinikey(argv[0],_T("history0"),_T("destination")));
    return 0;
}
*/
