/* Copyright (C) 2006-2008 VA007219 */
#include <windows.h>
#include <tchar.h>
#include <stdio.h>

int lasterror;
static _TCHAR msgbuff[2048 + LONGMAX_PATH];
extern _TCHAR *pgname;

int msgbox(HWND hWnd,UINT uType,_TCHAR *fmt, ...)
{
    LPVOID lpMsgBuf;
    va_list argp;
    int ret;

    if ( fmt != NULL && *fmt != 0 ) {
        va_start(argp, fmt);
        _vsntprintf(msgbuff,sizeof msgbuff / sizeof msgbuff[0] - 1,fmt,argp);
        va_end(argp);
    }
    FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        lasterror,
        MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0,
        NULL
    );
    if ( sizeof msgbuff > _tcslen(msgbuff) + _tcslen(lpMsgBuf) ) {
        _tcscat(msgbuff,lpMsgBuf);
    }
    LocalFree(lpMsgBuf);
    ret = MessageBox(hWnd,msgbuff,pgname,uType);
    return ret;
}

_TCHAR *errmsg(_TCHAR *buf,int size,_TCHAR *fmt, ...)
{
    LPVOID lpMsgBuf;
    va_list argp;

    if ( fmt != NULL && *fmt != 0 ) {
        va_start(argp, fmt);
        _vsntprintf(buf,size - 1,fmt,argp);
        va_end(argp);
    }
    FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        lasterror,
        MAKELANGID(LANG_NEUTRAL,SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0,
        NULL
    );
    if ( size > _tcslen(buf) + _tcslen(lpMsgBuf) ) {
        _tcscat(buf,lpMsgBuf);
    }
    LocalFree(lpMsgBuf);
    return buf;
}

